const WebSocketManager = require('/utils/websocket.js');
const eventMap = new Map();
let _webSocketManager = null;
let pathinfo = {
  url: '',
  title: '',
  referrer: 0
};
// var isonConnect = false; //是否已经连接
App({
  onLaunch(e) {
    // Join 场景值
    pathinfo.referrer = 'wxapp.' + e.scene
    //   获取路由
    wx.onAppRoute((res) => {
      let querystr = this.talkBuildQuery(res.query)
      let pathurl = ''
      if (querystr.length > 1) {
        pathurl = `${res.path}${querystr}`
      } else {
        pathurl = `${res.path}`
      }
      pathinfo.url = pathurl,
        pathinfo.title = res.page?.window?.navigationBarTitleText
      if (res.page?.window?.navigationBarTitleText) {
        if (res.page.window.navigationBarTitleText == '商品详情') {
          pathinfo.title = ''
        }
      }
      // 切换路由发送页面路径识别
      if (_webSocketManager) {
        _webSocketManager.sendJoin(pathinfo)
      }
    })
    this.on('linkSocket', this.route, this.talkSocketStateChange.bind(this));
  },

  // 事件订阅 app.on('sharenum',this.route,this.func.bind(this))
  on(action, path, event) {
    //   console.log(action,path, 'on');
    if (eventMap) {
      if (eventMap.has(action)) {
        var events = eventMap.get(action);
        events.set(path, event);
      } else {
        var events = new Map();
        events.set(path, event);
        eventMap.set(action, events)
      }
    }
  },
  // 事件卸载 app.off('sharenum' this.route);
  off(action, path) {
    // console.log(action,path, 'off');
    if (eventMap) {
      if (eventMap.has(action)) {
        var events = eventMap.get(action);
        events.delete(path);
      }
    }
  },
  // 事件触发 arg需要为字符串，在对应的地方自己拆装箱
  emit(action, arg) {
    if (action == 'sendJoin') {
      if (_webSocketManager) {
        let info = JSON.parse(arg)
        info.referrer = pathinfo.referrer
        _webSocketManager.sendJoin(info)
      }
    } else if (eventMap && eventMap.has(action)) {
      var events = eventMap.get(action);
      var funcs = events.values();
      for (var func of funcs) {
        func(arg);
      }
    }
  },
  onShow(e) {
    // 检测隐藏页面后是否断线 断线后会重新连接
    if (_webSocketManager) {
      _webSocketManager.checkLink();
    }
  },
  /**
* 对象转成&拼接参数
* @param {*} params 
* @returns 
*/
  talkBuildQuery(params) {
    var str = '';
    for (var Key in params) {
      str += Key + '=' + params[Key] + '&';
    }
    return '?' + str.substr(0, str.length - 1); //严谨一些 
  },
  /**
   * 开始链接
   * @param {*} wsUrl 
   * @param {*} talkToken 
   */
  talkStartLink(wsUrl, talkToken) {
    if (!this.globalData.talksocket) {
      _webSocketManager = new WebSocketManager(wsUrl, this, talkToken);
      this.globalData.talksocket = _webSocketManager;
    } else {
      _webSocketManager = this.globalData.talksocket;
      //假设给新的链接
      // wsUrl="";
      // talkToken="";
      _webSocketManager.newLinkConfig(wsUrl, talkToken);
    }
  },
  /**
   * 链接状态重新变更
   * @param {*} e 
   */
  talkSocketStateChange(e) {
    if (_webSocketManager) {
      _webSocketManager.sendJoin(pathinfo)
    }
  },
  globalData: {
    userInfo: null,
    backPayStatus: 0,
    webSocketManager: null,
    close_time: 5000,
  }
})
