const app = getApp();
var cangethistory = true;
var isloadinghistory = false
Component({
  lifetimes: {
    attached() {
      this.readLastPageHistory();
      let routes = getCurrentPages(); // 获取当前打开过的页面路由数组
      let curPath = routes[routes.length - 1].route;
      // 监听socket事件传递
      app.on('talkmessage', curPath, this.handlerSocketMessage.bind(this));
    }
  },
  /**
   * 组件的属性列表
   */
  properties: {
    showView: {
      type: Boolean,
      value: false
    },
    // 设置客服容器高度
    viewheight: {
      type: String,
      value: '90vh'
    },
    // 设置客服按钮距离页面底部高度
    msgbutton: {
      type: String,
      value: '200rpx'
    },
    // 设置页面进入类型 tabbar 或者 detail
    pagetype: {
      type: String,
      value: 'detail'
    },
    // 可以添加自己的字段判断是否显示客服图标
    extendStore: {
      type: Object,
      value: {}
    }
  },

  /**
   * 组件的初始数据
   */
  data: {
    show: false,
    inputHeight: 0,
    isGetFocus: false, //获取焦点
    holdKeyboard: true, //focus时，点击页面的时候不收起键盘
    content: '',
    messages: [],
    keyHeight: 0, //键盘高度
    scrollView: '', //滚动到某一位置
    style: {
      img: 'width:200rpx;'
    },
    systemInfo: '',
    showChat: false, //显示聊天
    firstid: 0, //历史消息起始
    endpage: 20, //历史消息起始
    nodata: false, //还有没有更多消息
    isgethistory: false, //获取过历史消息
    showRate: false, //评分弹窗
    ratevalue: 0,
    ratebody: '', //评分
    showmessage: false, //留言
    messagevalue: '',
    queue_index: 0, //排队人数
    showLineUpText: '',
    getphone: '', //手机号码
    chatWindowHeight: 0, //聊天视图高度
    isBottomScroll: true, //是否消息在最底下
    showGoods: false, //商品外显
    outerMsg: {}, //商品外显数据
    groupBuyItem: {}, //参团红包数据
    chat_min_id: 0,
    chat_max_id: 0,
    addLink: 0, //链接次数
    linksound: '',
    ChatMsg: '',
    showChatMsg: false,
    chatMsgList: [],
    loading: false, //加载动画
    msgAnim: false, //呼吸灯
    msgnum_count: 0,
    timer: null,
    timergroup: null,
    showItem: {}, //外显数据
    app_name: '客服',//这个的更新，要使用主动模式还是被动模式？
    buttons: [],//固定按钮
    read_config_info: false,//是否已经读取过配置信息 buttons app_name等
    read_last_page: true,
    starList: [1, 2, 3, 4, 5],
    startValue: 5//默认5星星好评
  },
  detached() {
    // 销毁事件
    let routes = getCurrentPages(); // 获取当前打开过的页面路由数组
    let curPath = routes[routes.length - 1].route;
    app.off('talkmessage', curPath);
  },
  /**
   * 组件的方法列表
   */
  methods: {

    /**
     * 获取最后一页数据
     */
    readLastPageHistory() {
      if (app.globalData.talksocket) {
        // 获取历史消息
        var _msgs = app.globalData.talksocket.handlerGetLastPageMessage();
        if (_msgs == null) {
          this.data.read_last_page = false;
        } else {
        }
        if (_msgs && _msgs.length > 0) {
          var _msg_str = JSON.stringify(_msgs);
          var _chats = JSON.parse(_msg_str);
          for (var _chat of _chats) {
            this.handlerChatMessage(_chat, 'history');
          }
          this.setData({
            messages: this.data.messages
          })
          if (this.data.isBottomScroll) {
            setTimeout(() => {
              this.setData({
                scrollView: 'scroll-into-last'
              })
            }, 100)
          }
          setTimeout(() => {
            this.setData({
              loading: false
            })
          }, 1000);
        }
      }
    },

    /**
     * WebSocket过来的消息，包含多个类型，已经是经过处理的消息
     * @param {*} info 
     */
    handlerSocketMessage(info) {
      switch (info.target) {
        case "Msg": {
          this.handlerChatMessage(info.data, 'online');
          if (info.from) {
            if (info.from == 'Speak') {
              this.setData({
                content: ''
              });
            }
          }
        }
          break;
        case "OpenWindow": {
          this.setData({
            showChat: true
          })
          if (!this.data.read_last_page) {
            this.data.read_last_page = true;
            this.readLastPageHistory();
          }
          this.readAppConfig();
        }
          break;
        case 'OpenScore': {
          // 弹起评分弹窗，评分后发送
          this.setData({
            showRate: true
          })
        }
          break;
        case 'OpenMessage': {
          this.setData({
            showmessage: true
          })
        }
          break;
        case "Score": {
          // 收到评分答复 关闭弹窗
          this.setData({
            showRate: false
          })
        }
          break;
        case "Message": {
          // 隐藏留言窗
          this.setData({
            showmessage: false
          })
        }
          break;
        case "QueueIndex": {
          var _num = Number(info.data);
          if (_num != NaN && _num) {
            this.setData({
              queue_index: _zindex,
              showLineUpText: `当前排队人数: ${_zindex}`,
            })
          }
        }
          break;
        case 'CallBack': {
          var _chat_id = info.data;
          if (typeof _chat_id != 'number') {
            _chat_id = Number(info.data);
          }
          for (const i in this.data.messages) {
            if (this.data.messages[i].id == _chat_id) {
              this.data.messages.splice(i, 1)
              break;
            }
          }
          //是否需要更新UI?
        }
        case 'Join': {
          if (info.data.app_name) {
            this.setData({
              app_name: info.data.app_name
            });
          }
          if (info.data.queue_index <= 0) {
            // 不显示排队信息
          } else {
            // 当前排队人数
            if (info.data.queue_index) {
              this.data.queue_index = info.data.queue_index
              this.setData({
                showLineUpText: `当前排队人数: ${this.data.queue_index}`,
                queue_index: this.data.queue_index
              })
            }
          }
        }
          break;
        case 'Msgs': {
          // 历史消息
          isloadinghistory = false
          this.data.read_last_page = true;
          var _chats = info.data.reverse();
          for (const i of _chats) {
            if (i.msg_type == 3 || i.msg_type == 5 || i.msg_type == 9 || i.msg_type == 12 || i.msg_type == 15 || i.msg_type >100) {
              if (typeof i.msg == 'string') {
                if (i.msg.indexOf('{') != -1) {
                  i.msg = JSON.parse(i.msg)
                }
              }
            }
            this.handlerSetMaxMinChatId(i);
          }
          this.data.messages = [..._chats, ...this.data.messages]
          this.data.scrollView = 'scroll-into-view' + this.data.firstid
          this.setData({
            messages: this.data.messages
          })
          this.setData({
            scrollView: this.data.scrollView,
            loading: false
          })
        }
          break;
        case 'nodata': {
          isloadinghistory = false
          this.setData({
            loading: false
          })
        }
      }
    },
    /**
     * 处理聊天消息 实时消息
     * 不进行更新UI和滚动条更新
     * @param {*} msgitem chatModel
     * @param {*} args 暂时无用
     */
    handlerChatMessage(msgitem, args) {
      if (msgitem.msg_type == 3 || msgitem.msg_type == 5 || msgitem.msg_type == 9 || msgitem.msg_type == 12 || msgitem.msg_type == 15) {
        if (typeof msgitem.msg == 'string') {
          msgitem.msg = JSON.parse(msgitem.msg)
          if (msgitem.msg.amount) {
            msgitem.msg.amount = (msgitem.msg.amount / 100).toFixed(0);
          }
        }
      }
      //把数据插入到聊天消息集合中并记录最大ID，最小ID
      var _append = this.handlerAppendInsertChatMessage(msgitem);
      if (_append) {
        if (!this.data.showChat && this.data.linksound) {
          const innerAudioContext = wx.createInnerAudioContext();
          innerAudioContext.autoplay = true;
          innerAudioContext.src = this.data.linksound;
          innerAudioContext.onPlay(() => {
            // console.log('开始播放');
          });
        }
      }
      if (_append) {
        if (msgitem.talk_type == 2) {
          this.setData({
            queue_index: 0,
            showLineUpText: ''
          })
        }
      }
      if (args == 'online') {
        if (!this.data.showChat) {
          this.setData({
            msgAnim: true,
            msgnum_count: this.data.msgnum_count + 1
          })
        }
        this.setData({
          messages: this.data.messages
        })
        if (this.data.showChat) {
          if (this.data.isBottomScroll) {
            setTimeout(() => {
              this.setData({
                scrollView: 'scroll-into-last'
              })
            }, 100)
          } else {
            // console.log('socket来消息了，但是不需要滚动到下方');
          }
        }
        //消息外显，在线的才要外显
        if (msgitem.outer) {
          if (msgitem.msg_type == 3 && msgitem.msg.showstyle == 0) {
            this.triggerEvent('couponFun', msgitem.msg)
            return;
          }
          if (this.timer) {
            clearTimeout(this.timer);
          }
          var _timeout = app.globalData.close_time;
          //timeout 重置
          if (msgitem.msg) {
            if (msgitem.msg.timeout) {
              _timeout = msgitem.msg.timeout * 1000;
            }
          }
          this.setData({
            outerMsg: msgitem
          })
          this.timer = setTimeout(() => {
            this.setData({
              outerMsg: {}
            })
          }, _timeout);
        }
      }
    },
    /**
     * 判断更新最小ID，最大ID，并执行插入或者追加到列表中，注意没有更新UI
     * @param {*} _chat 
     */
    handlerAppendInsertChatMessage(_chat) {
      var _append = this.handlerSetMaxMinChatId(_chat);
      if (_append) {
        this.data.messages.push(_chat);
      } else {
        this.data.messages.unshift(_chat);
      }
      return _append;
    },
    /**
     * 判断更新最小ID，最大ID，并执行插入或者追加到列表中，注意没有更新UI
     * @param {*} _chat 
     */
    handlerSetMaxMinChatId(_chat) {
      var _append = true;
      if (_chat.id) {
        if (this.data.chat_max_id == 0 || this.data.chat_max_id < _chat.id) {
          this.data.chat_max_id = _chat.id;
        }
        if (this.data.chat_min_id > _chat.id || this.data.chat_min_id == 0) {
          if (this.data.chat_min_id > 0) {
            _append = false;
          }
          this.data.chat_min_id = _chat.id;
        }
      }
      return _append;
    },
    /**
     * 点击固定按钮触发的事件
     */
    fixedButtonTap(e) {
      // console.log(e);
      if (e.currentTarget.dataset.event) {
        var code = e.currentTarget.dataset.event;
        let routes = getCurrentPages(); // 获取当前打开过的页面路由数组
        let curParam = routes[routes.length - 1].options;
        let curPage = routes[routes.length - 1].route;
        let params = this.addQueryString(curParam)
        let info = {
          type: 'Cevent',
          args: [code, curPage + params]
        }
        this.handlerSendMessage(info);
      }
      if (e.currentTarget.dataset.word) {
        //快选回复
        let choose_text = e.currentTarget.dataset.word
        let info = {
          type: 'Speak',
          args: {
            "Msg": choose_text,
            "Msg_type": 10
          }
        }
        this.handlerSendMessage(info);
        setTimeout(() => {
          this.setData({
            scrollView: 'scroll-into-last'
          })
        }, 100)
      }
    },
    closeChatMsg() {
      this.setData({
        showChatMsg: false,
        ChatMsg: ''
      })
    },
    handleUpChatMsg(e) {
      let code = e.currentTarget?.dataset?.ecode;
      setTimeout(() => {
        this.setData({
          scrollView: 'scroll-into-last',
          msgnum_count: 0,
          msgAnim: false
        })
      }, 10);
      //  主动打开    windonw 1 0
      let info = {
        type: 'TapWindow',
        args: 1
      }
      this.handlerSendMessage(info);
      if (code) {
        let routes = getCurrentPages(); // 获取当前打开过的页面路由数组
        let curParam = routes[routes.length - 1].options;
        let curPage = routes[routes.length - 1].route;
        let params = this.addQueryString(curParam)
        let info = {
          type: 'Cevent',
          args: [code, curPage + params]
        }
        this.handlerSendMessage(info);
      }
      if (this.data.pagetype == 'detail') {
        this.setData({
          showChatMsg: false,
          ChatMsg: '',
          showChat: true,
          msgnum_count: 0,
          msgAnim: false
        })
      }
      if (!this.data.read_last_page) {
        // console.log('上次获取最后一页数据失败，本次进行补充');
        this.data.read_last_page = true;
        this.readLastPageHistory();
      }
      this.readAppConfig();
    },
    /**
     * 对象转成&拼接参数
     * @param {*} params 
     * @returns 
     */
    addQueryString(params) {
      var str = '';
      for (var Key in params) {
        str += Key + '=' + params[Key] + '&';
      }
      return '?' + str.substr(0, str.length - 1); //严谨一些 
    },
    // 关闭弹窗
    onCloseRate() {
      this.setData({
        showRate: false
      })
    },
    // 打开留言
    handleClickShowMessage() {
      this.setData({
        showmessage: true
      })
    },
    // 关闭弹窗
    onCloseMsg() {
      this.setData({
        showmessage: false
      })
    },
    // 修改评分
    onChangeRate(e) {
      this.setData({
        ratevalue: e.detail
      })
    },
    handleRateText(e) {
      this.setData({
        ratebody: e.detail.value
      })
    },
    // 离线留言
    handleMsgText(e) {
      this.setData({
        messagevalue: e.detail.value
      })
    },
    // 联系方式
    handleMsgPhone(e) {
      this.setData({
        getphone: e.detail.value
      })
    },
    // 图片加载完成滚动到底部
    handleImageLoad() {
      if (this.data.isBottomScroll) {
        this.setData({
          scrollView: 'scroll-into-last'
        })
      }
    },
    // 提交留言
    submitMessage() {
      let info = {
        type: 'Message',
        args: {
          title: this.data.getphone,
          body: this.data.messagevalue
        }
      }
      if (!info.args.body) {
        wx.showToast({
          title: '留言内容不能为空',
          icon: 'none'
        })
        return;
      }
      this.handlerSendMessage(info);
    },
    // 提交评分
    submitRate() {
      let info = {
        type: 'Score',
        args: {
          score: this.data.startValue,
          body: this.data.ratebody
        }
      }
      this.handlerSendMessage(info);
    },
    // 历史消息处理
    handleTypeMsg(data) {
      for (const i of data) {
        // 优惠券卡片3 商品卡片 5 选项卡片 9
        if (i.msg_type == 3 || i.msg_type == 5 || i.msg_type == 9 || i.msg_type == 12 || i.msg_type == 15 || i.msg_type>100) {
          if (typeof i.msg == 'string') {
            if (i.msg.indexOf('{') != -1) {
              i.msg = JSON.parse(i.msg)
            }
          }
        }
      }
      return data
    },
    // 历史消息
    gethistory() {
      if (this.data.isBottomScroll) {
        this.data.isBottomScroll = false;
      }
      this.data.firstid = this.data.messages[0].id
      this.data.scrollView = 'scroll-into-view' + this.data.firstid
      if (!isloadinghistory) {
        isloadinghistory = true
        //互斥开关
        if (app.globalData.talksocket) {
          this.setData({
            loading: true
          })
          setTimeout(() => {
            app.globalData.talksocket.handlerGetSocketPrePageMessage(this.data.chat_min_id);
          }, 500)
        } else {
          isloadinghistory = false
        }
      }
    },
    handleScrollButtom() {
      if (!this.data.isBottomScroll) {
        this.data.isBottomScroll = true;
      }
    },
    messageInputFocusin() {
      wx.onKeyboardHeightChange(res => {
        this.keyHeight = res.height
        this.data.inputHeight = this.keyHeight
      })
    },
    handleClickHide() {
      this.data.inputHeight = 0
    },
    showImage(e) {
      let url = e.currentTarget.dataset.url
      wx.previewImage({
        urls: [url]
      })
    },
    handleClickShow() {
      this.setData({
        isShow: false
      })
    },
    handleClickGoLink(e) {
      let path = e.currentTarget.dataset.path
      wx.reLaunch({
        url: path,
      })
    },
    bindTextAreaBlur(e) {
      this.data.content = e.detail.value
      this.setData({
        content: this.data.content
      })
    },
    sendTextMessage(e) {
      if (!this.data.content) {
        return wx.showToast({
          title: '发送消息不能为空',
          icon: 'none'
        })
      }
      let inputvalue = e.currentTarget.dataset.index
      let info = {
        type: 'Speak',
        args: {
          "Msg": this.data.content,
          "Msg_type": 0
        }
      }
      this.data.isBottomScroll = true
      this.handlerSendMessage(info);
    },
    sendImage() {
      wx.chooseMedia({
        count: 1,
        mediaType: ['image'],
        sizeType: ['original', 'compressed'],
        sourceType: ['album', 'camera'],
        success: async (res) => {
          // console.log(res);
          // tempFilePath可以作为img标签的src属性显示图片
          const tempFilePaths = res.tempFiles;
          if (tempFilePaths) {
            // let base64Image = await this.imgToBase64(tempFilePaths[0])
            if (this.data.systemInfo == 'android') {
              await this.handleCompressAndroid(tempFilePaths[0])
            } else if (this.data.systemInfo == 'ios') {
              let urlArr = tempFilePaths[0].split('.')
              // ios且图片格式是jpg
              if (urlArr[1] == 'jpg' || urlArr[1] == 'JPG') {
                await this.handleCompressAndroid(tempFilePaths[0])
              } else {
                // 图片canvas压缩
                this.handleCanvasIOS(tempFilePaths[0])
              }
            } else {
              // 其他情况
              await this.handleCompressAndroid(tempFilePaths[0])
            }
          } else {
            console.warn('没有获取到选中的图片');
          }
        }
      })
    },
    // 压缩安卓图片 ios 支持jpg格式
    async handleCompressAndroid(_file) {
      let base64Image = await this.imgToBase64(_file.tempFilePath)
      // let imagnameArr = res.tempFilePath.split("//")
      let info = {
        type: 'File',
        args: {
          "data": base64Image,
          "id": 0,
          "type": "img",
          "file_name": _file.tempFilePath
        }
      }
      this.data.isBottomScroll = true
      this.handlerSendMessage(info);
    },
    handleCanvasIOS(url) {
      const query = this.createSelectorQuery()
      let dom = query.select('#canvasId') //画布id
      dom.fields({
        node: true,
        size: true
      })
        .exec((res) => {
          const canvas = res[0].node
          canvas.width = 750 //压缩后宽
          canvas.height = 750 //压缩后高
          const ctx = canvas.getContext('2d')
          let img = canvas.createImage();
          img.src = url; //要压缩的图片路径
          img.onload = () => {
            // 将图片绘制到canvas
            ctx.drawImage(img, 0, 0, canvas.width, canvas.height)
            //大于4096的先转base64，再写入文件
            if (canvas.width > 4096 || canvas.width > 4096) {
              //转成base64图片后的质量和类型
              const base64Data = canvas.toDataURL('image/jpeg', 0.8);
              const base64 = base64Data.replace(/^data:image\/\w+;base64,/, '');
              let imagnameArr = url.split("//")
              let info = {
                type: 'File',
                args: {
                  "data": base64,
                  "id": 0,
                  "type": "img",
                  "file_name": imagnameArr[1]
                }
              }
              this.data.isBottomScroll = true
              this.handlerSendMessage(info);
            } else {
              // 生成图片
              wx.canvasToTempFilePath({
                canvas,
                destWidth: 750, //压缩后宽
                destHeight: 750, //压缩后高
                fileType: 'jpg',
                quality: 0.5, //质量，可自定义
                success: async (fileres) => {
                  let base64Image = await this.imgToBase64(fileres.tempFilePath)
                  let imagnameArr = fileres.tempFilePath.split("//")
                  let info = {
                    type: 'File',
                    args: {
                      "data": base64Image,
                      "id": 0,
                      "type": "img",
                      "file_name": imagnameArr[1]
                    }
                  }
                  this.data.isBottomScroll = true
                  this.handlerSendMessage(info);
                },
                fail: (err) => {
                  console.error(err);
                }
              })
            }
          }
        })
    },
    imgToBase64(filePath) {
      return new Promise((resolve, reject) => {
        let baseFormat = 'data:image/png;base64,'
        let base64 = wx.getFileSystemManager().readFileSync(filePath, 'base64')
        resolve(baseFormat + base64)
      })
    },
    /**
     * 读取配置信息
     */
    readAppConfig() {
      if (!this.data.read_config_info) {
        if (app.globalData.talksocket) {
          var _read = app.globalData.talksocket.basicinfo;
          if (_read != null) {
            this.data.read_config_info = true;
            this.setData({
              buttons: _read.app_buttons,
              app_name: _read.app_name
            });
          }
        }
      }
    },
    /**
     * 关闭对话框
     */
    maskClose() {
      this.setData({
        showChat: false
      })
      this.triggerEvent('closeChat', false)
    },
    /**
     * 快选模式，选择答案
     * @param {*} e 
     */
    handleClickChooseItem(e) {
      let choose_text = e.currentTarget.dataset.items
      let info = {
        type: 'Speak',
        args: {
          "Msg": choose_text,
          "Msg_type": 10
        }
      }
      this.handlerSendMessage(info);
      setTimeout(() => {
        this.setData({
          scrollView: 'scroll-into-last'
        })
      }, 100)
    },
    /**
     * 发送消息
     * @param {*} obj type,args jsonstring或者object
     */
    handlerSendMessage(obj) {
      if (app.globalData.talksocket) {
        if (typeof (obj) == 'string') {
          let info = JSON.parse(obj)
          app.globalData.talksocket.sendMessage(info.args, info.type)
        } else {
          app.globalData.talksocket.sendMessage(obj.args, obj.type)
        }
      }
    },
    /**
     * 点击星星进行评分
     * @param {*} e 
     */
    onRateTap(e) {
      this.setData({
        startValue: e.currentTarget.dataset.start
      });
    }
  }
})